/****************************************************************************
    Qt-LCoV Library Editor for Qt-BSch3V
    Copyright (C) 2002-2005 H.Okada

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*****************************************************************************/

#include <string.h>
#include <qmessagebox.h>

void prop_comp::onOK()
{
//qDebug("prop_comp::onOK()");
	QString str;
	str=editName->text();
	if(!isValidName(str.latin1())){
		QMessageBox::critical( this, "Component attribute",
							"Invalid component name",
							"OK",QString::null,QString::null,0,0);
		return;
	}
	int n;
	
	str=editWidth->text();
	n=str.toInt();
	if(n<1||255<n){
		QMessageBox::critical( this, "Component attribute",
							"Width must be between 1 and 255.",
							"OK",QString::null,QString::null,0,0);
		return;
	}
	
	str=editHeight->text();
	n=str.toInt();
	if(n<1||255<n){
		QMessageBox::critical( this, "Component attribute",
							"Height must be between 1 and 255.",
							"OK",QString::null,QString::null,0,0);
		return;
	}
	

	str=editBlock->text();
	n=str.toInt();
	if(n<1||255<n){
		QMessageBox::critical( this, "Component attribute",
							"Block must be between 1 and 255.",
							"OK",QString::null,QString::null,0,0);
		return;
	}
	
	accept();	
}


bool prop_comp::isValidName( const char *psz )
{
	int n=strlen(psz);
	if(n==0 || n>15) return false;
	while(*psz){
		if(  *psz<0x21
		   ||*psz>0x7E
   		   ||*psz=='{'
		   ||*psz=='}') return false;
		psz++;
	}
	return true;
}
